{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}

{$IFDEF DPMI}
This unit cannot be compiled with Protected Mode Target!
{$ENDIF}

{$IFDEF WINDOWS}
This unit cannot be compiled with Windows Target!
{$ENDIF}

UNIT StringManipulation;

{
  StringManipulation.TPU source code
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  Copyright 1995-96 `CIRCLE' // `CIRCLE' Designs

  This is not a public-domain or freeware source code.

  FidoNet: 2:5003/15
  E-Mail: picoder@mercury.gaianet.net
}

INTERFACE

FUNCTION CharReplicate(Character: CHAR; Count: BYTE): STRING;
{
Replicates character Character Count times.
}
FUNCTION StringReplicate(Source: STRING; Count: BYTE): STRING;
{
Replicates string Source Count times.
}
FUNCTION CharPos(CharToFind: CHAR; Source: STRING; Offs: BYTE): BYTE;
{
Searches for a character CharToFind in a string Source starting
at Offs. Returns zero if not found.
}
FUNCTION StringPos(StringToFind: STRING; Source: STRING; Offs: BYTE): BYTE;
{
Searches for a substring StringToFind in a string Source starting
at Offs. Returns zero if not found.
}
FUNCTION StringCase(Source: STRING; ToCase: POINTER): STRING;
{
Translates Source string's characters to desired case ToCase.
}
FUNCTION StringReverse(Source: STRING): STRING;
{
Reverses string Source as follows: 'today' to 'yadot'.
}
FUNCTION StringFromData(Source: POINTER; Count: BYTE): STRING;
{
Returns string of Count characters from Source location.
}
FUNCTION StringFromNul(Source: POINTER): STRING;
{
Converts ASCIZ string Source to Pascal-style string.
}
FUNCTION StringExtract(Source: STRING; Offs: BYTE; Count: BYTE): STRING;
{
Extracts substring Count-sized from a string Source starting at
offset Offs.
}
FUNCTION StringRemove(Source: STRING; Offs: BYTE; Count: BYTE): STRING;
{
Removes Count characters from string Source starting at
offset Offs.
}
FUNCTION StringInsert(SubString: STRING; Source: STRING; Offs: BYTE): STRING;
{
Inserts substring SubString to a string Source starting at
offset Offs.
}
FUNCTION StringJustifyRight(Source: STRING; Width: BYTE; JustifyChar: CHAR): STRING;
{
Right-justifies string Source padding it with character JustifyChar.
}
FUNCTION StringJustifyLeft(Source: STRING; Width: BYTE; JustifyChar: CHAR): STRING;
{
Left-justifies string Source padding it with character JustifyChar.
}
FUNCTION StringJustifyCenter(Source: STRING; Width: BYTE; JustifyChar: CHAR): STRING;
{
Center-justifies string Source padding it with character JustifyChar.
}
FUNCTION StringJustifyWrap(Source: STRING; Width: BYTE; WordDelimiters: STRING; JustifyChar: CHAR): STRING;
{
Stretches string Source to length Width adding character JustifyChar
between words delimited with WordDelimiters.
}
FUNCTION StringTrimRight(Source: STRING; Garbage: STRING): STRING;
{
Trims rightmost "unwanted" characters Garbage in string Source.
}
FUNCTION StringTrimLeft(Source: STRING; Garbage: STRING): STRING;
{
Trims leftmost "unwanted" characters Garbage in string Source.
}
FUNCTION StringTrimAll(Source: STRING; Garbage: STRING): STRING;
{
Trims rightmost and leftmost "unwanted" characters Garbage in
string Source.
}
FUNCTION StringWordCount(Source: STRING; WordDelimiters: STRING): BYTE;
{
Returns number of words contained in string Source
and delimited with WordDelimiters.
}
FUNCTION StringWordGet(Source: STRING; WordDelimiters: STRING; Count: BYTE): STRING;
{
Returns Count word from string Source delimited to words
by WordDelimiters.
}
FUNCTION StringWordPos(Source: STRING; WordDelimiters: STRING; Count: BYTE): BYTE;
{
Returns position of Count word in string Source delimited to words
by WordDelimiters. Returns zero if invalid Count specified.
}

CONST { LowerCase for english and russian }
	LowerCase: ARRAY[0..255] OF CHAR = (#0,#1,#2,#3,#4,#5,#6,#7,#8,#9,#10,#11,#12,
	#13,#14,#15,#16,#17,#18,#19,#20,#21,#22,#23,#24,#25,#26,#27,#28,#29,#30,#31,
	#32,#33,#34,#35,#36,#37,#38,#39,#40,#41,#42,#43,#44,#45,#46,#47,#48,#49,#50,
	#51,#52,#53,#54,#55,#56,#57,#58,#59,#60,#61,#62,#63,#64,#97,#98,#99,#100,#101,
	#102,#103,#104,#105,#106,#107,#108,#109,#110,#111,#112,#113,#114,#115,#116,
	#117,#118,#119,#120,#121,#122,#91,#92,#93,#94,#95,#96,#97,#98,#99,#100,#101,
	#102,#103,#104,#105,#106,#107,#108,#109,#110,#111,#112,#113,#114,#115,#116,
	#117,#118,#119,#120,#121,#122,#123,#124,#125,#126,#127,#160,#161,#162,#163,
	#164,#165,#166,#167,#168,#169,#170,#171,#172,#173,#174,#175,#224,#225,#226,
	#227,#228,#229,#230,#231,#232,#233,#234,#235,#236,#237,#238,#239,#160,#161,
	#162,#163,#164,#165,#166,#167,#168,#169,#170,#171,#172,#173,#174,#175,#176,
	#177,#178,#179,#180,#181,#182,#183,#184,#185,#186,#187,#188,#189,#190,#191,
	#192,#193,#194,#195,#196,#197,#198,#199,#200,#201,#202,#203,#204,#205,#206,
	#207,#208,#209,#210,#211,#212,#213,#214,#215,#216,#217,#218,#219,#220,#221,
	#222,#223,#224,#225,#226,#227,#228,#229,#230,#231,#232,#233,#234,#235,#236,
	#237,#238,#239,#240,#241,#242,#243,#244,#245,#246,#247,#248,#249,#250,#251,
	#252,#253,#254,#255);

CONST { UpperCase for english and russian }
	UpperCase: ARRAY[0..255] OF CHAR = (#0,#1,#2,#3,#4,#5,#6,#7,#8,#9,#10,#11,#12,
	#13,#14,#15,#16,#17,#18,#19,#20,#21,#22,#23,#24,#25,#26,#27,#28,#29,#30,#31,
	#32,#33,#34,#35,#36,#37,#38,#39,#40,#41,#42,#43,#44,#45,#46,#47,#48,#49,#50,
	#51,#52,#53,#54,#55,#56,#57,#58,#59,#60,#61,#62,#63,#64,#65,#66,#67,#68,#69,
	#70,#71,#72,#73,#74,#75,#76,#77,#78,#79,#80,#81,#82,#83,#84,#85,#86,#87,#88,
	#89,#90,#91,#92,#93,#94,#95,#96,#65,#66,#67,#68,#69,#70,#71,#72,#73,#74,#75,
	#76,#77,#78,#79,#80,#81,#82,#83,#84,#85,#86,#87,#88,#89,#90,#123,#124,#125,
	#126,#127,#128,#129,#130,#131,#132,#133,#134,#135,#136,#137,#138,#139,#140,
	#141,#142,#143,#144,#145,#146,#147,#148,#149,#150,#151,#152,#153,#154,#155,
	#156,#157,#158,#159,#128,#129,#130,#131,#132,#133,#134,#135,#136,#137,#138,
	#139,#140,#141,#142,#143,#176,#177,#178,#179,#180,#181,#182,#183,#184,#185,
	#186,#187,#188,#189,#190,#191,#192,#193,#194,#195,#196,#197,#198,#199,#200,
	#201,#202,#203,#204,#205,#206,#207,#208,#209,#210,#211,#212,#213,#214,#215,
	#216,#217,#218,#219,#220,#221,#222,#223,#144,#145,#146,#147,#148,#149,#150,
	#151,#152,#153,#154,#155,#156,#157,#158,#159,#240,#241,#242,#243,#244,#245,
	#246,#247,#248,#249,#250,#251,#252,#253,#254,#255);

IMPLEMENTATION

FUNCTION CharReplicate(Character: CHAR; Count: BYTE): STRING;
ASSEMBLER;
ASM
	CLD

	LES DI,[@Result]

	MOV AL,[Count]
	MOV CL,AL
	XOR CH,CH
	STOSB

	MOV AL,[Character]
	MOV AH,AL

	SHR CX,1
	JNC @@FillWords

	STOSB

@@FillWords:
	REP STOSW
END;

FUNCTION StringCase(Source: STRING; ToCase: POINTER): STRING;
ASSEMBLER;
ASM
	CLD

	PUSH DS

	LDS SI,[Source]
	MOV CL,[DS:SI]
	CMP CL,0
	JE @@ZeroResult

	INC SI
	XOR CH,CH
	MOV DX,CX

	LES DI,[@Result]
	MOV [ES:DI],CL
	INC DI

	SHR CX,1
	JNC @@DoWords

	MOVSB

@@DoWords:
	REP MOVSW

	MOV DI,[WORD PTR @Result]
	LDS BX,[ToCase]

	MOV CX,DX

@@Loop1:
	INC DI
	MOV AL,[ES:DI]
	XLAT
	MOV [ES:DI],AL
	LOOP @@Loop1

	JMP @@Done

@@ZeroResult:
	LES DI,[@Result]
	MOV [BYTE PTR ES:DI],0H

@@Done:
	POP DS
END;

FUNCTION CharPos(CharToFind: CHAR; Source: STRING; Offs: BYTE): BYTE;
ASSEMBLER;
ASM
	CLD

	LES DI,[Source]

	MOV CL,[ES:DI]
	XOR CH,CH
	MOV AL,[Offs]
	XOR AH,AH

	XOR BH,BH

	CMP AL,CL
	JAE @@Done

	SUB CX,AX
	ADD DI,AX
	INC DI

	MOV BL,CL
	MOV AL,[CharToFind]
	REPNE SCASB
	JNE @@Done

	SUB BL,CL
	MOV BH,BL
	ADD BH,[Offs]

@@Done:
	MOV AL,BH
END;

FUNCTION StringReverse(Source: STRING): STRING;
ASSEMBLER;
ASM
	STD

	MOV DX,DS

	LDS SI,[Source]
	LES DI,[@Result]

	MOV AL,[DS:SI]
	XOR AH,AH

	MOV [ES:DI],AL
	INC DI
	CMP AL,0
	JE @@Done

	ADD SI,AX
	MOV CX,AX
	SHR CX,1
	JNC @@Label1

	LODSB
	MOV [ES:DI],AL
	INC DI

@@Label1:
	JCXZ @@Done

	DEC SI

@@LoopWords:
	LODSW
	XCHG AL,AH
	MOV [ES:DI],AX
	ADD DI,2
	LOOP @@LoopWords

@@Done:
	MOV DS,DX
END;

FUNCTION StringFromData(Source: POINTER; Count: BYTE): STRING;
ASSEMBLER;
ASM
	CLD

	MOV DX,DS

	LDS SI,[Source]
	LES DI,[@Result]

	MOV AL,[Count]
	XOR AH,AH
	STOSB

	MOV CX,AX
	SHR CX,1
	JNC @@MoveWords

	MOVSB

@@MoveWords:
	REP MOVSW

	MOV DS,DX
END;

FUNCTION StringFromNul(Source: POINTER): STRING;
ASSEMBLER;
ASM
	CLD

	MOV BX,DS

	LES DI,[Source]

	MOV CX,255
	MOV AX,0FF00H
	REPNE SCASB

	XCHG AH,AL
	SUB AX,CX
	MOV CX,ES
	MOV DS,CX
	SUB DI,AX
	MOV SI,DI
	LES DI,[@Result]
	DEC AX
	STOSB

	MOV CX,AX
	SHR CX,1
	JNC @@DoWords

	MOVSB

@@DoWords:
	REP MOVSW

	MOV DS,BX
END;

FUNCTION StringPos(StringToFind: STRING; Source: STRING; Offs: BYTE): BYTE;
ASSEMBLER;
ASM
	CLD

	PUSH DS

	XOR AH,AH
	XOR CH,CH

	LDS SI,[StringToFind]
	LES DI,[Source]

	MOV DL,[ES:DI]
	INC DI
	MOV AL,[Offs]
	CMP AL,DL
	JAE @@Hehe

	SUB DL,AL
	MOV BH,DL
	ADD DI,AX

	MOV BL,[DS:SI]
	INC SI

	CMP BL,0
	JE @@Hehe

	MOV DX,SI

@@ScanLoop:
	MOV CL,BL
	CMP CL,BH
	JA @@Hehe

	MOV AX,DI
	MOV SI,DX
	SHR CX,1
	JNC @@DoScanWords

	CMPSB
	JNE @@NotEqual

@@DoScanWords:
	REPE CMPSW
	JNE @@NotEqual

	MOV DI,[WORD PTR Source]
	MOV AL,[ES:DI]
	SUB AL,BH
	INC AL
	JMP @@Done

@@NotEqual:
	MOV DI,AX
	INC DI
	DEC BH
	JNZ @@ScanLoop

@@Hehe:
	XOR AL,AL

@@Done:
	POP DS
END;

FUNCTION StringExtract(Source: STRING; Offs: BYTE; Count: BYTE): STRING;
ASSEMBLER;
ASM
	CLD

	PUSH DS

	LDS SI,[Source]
	LES DI,[@Result]
	LODSB
	XOR AH,AH
	MOV BL,[Offs]
	XOR BH,BH
	CMP BL,AL
	JAE @@DoneZero

	ADD SI,BX
	MOV CL,[Count]
	XOR CH,CH
	ADD BX,CX
	CMP BX,AX
	JBE @@MoveIt

	SUB BX,AX
	SUB CX,BX

@@MoveIt:
	MOV [ES:DI],CL
	INC DI
	SHR CX,1
	JNC @@DoWords

	MOVSB

@@DoWords:
	REP MOVSW
	JMP @@Done

@@DoneZero:
	MOV [BYTE PTR ES:DI],0H

@@Done:
	POP DS
END;

FUNCTION StringRemove(Source: STRING; Offs: BYTE; Count: BYTE): STRING;
ASSEMBLER;
ASM
	CLD

	PUSH DS

	LDS SI,[Source]
	LES DI,[@Result]

	LODSB
	XOR AH,AH

	MOV CL,[Offs]
	XOR CH,CH
	CMP CL,AL
	JBE @@NoBound

	XOR CL,CL
	MOV [Count],CL
	MOV [Offs],CL

@@NoBound:
	SUB AX,CX
	MOV BX,DI
	INC DI
	SHR CX,1
	JNC @@DoWords1

	MOVSB

@@DoWords1:
	REP MOVSW

	MOV CL,[Count]
	CMP CX,AX
	JBE @@MoveIt

	MOV CX,AX

@@MoveIt:
	MOV DX,AX
	SUB DX,CX
	ADD SI,CX
	MOV CX,DX

	SHR CX,1
	JNC @@DoWords2

	MOVSB

@@DoWords2:
	REP MOVSW

	ADD DL,[Offs]
	MOV [ES:BX],DL

	POP DS
END;

FUNCTION StringInsert(SubString: STRING; Source: STRING; Offs: BYTE): STRING;
ASSEMBLER;
VAR
	InCount: WORD;
	AfterCount: WORD;
ASM
	CLD

	PUSH DS

	LES DI,[@Result]

	LDS SI,[SubString]
	MOV CL,[DS:SI]
	XOR CH,CH

	LDS SI,[Source]
	MOV AL,[DS:SI]
	XOR AH,AH
	INC SI

	MOV BL,[Offs]
	XOR BH,BH

	CMP BX,AX
	JB @@Adjust1

	MOV BL,AL
	MOV DX,AX
	MOV [InCount],0
	MOV [AfterCount],0
	JMP @@DoCopies

@@Adjust1:
	MOV DX,BX

	SUB AX,BX
	ADD BX,CX
	CMP BX,255
	JB @@Adjust2

	SUB BX,255
	SUB CX,BX
	MOV [InCount],CX
	MOV [AfterCount],0
	MOV BL,255
	JMP @@DoCopies

@@Adjust2:
	MOV [InCount],CX

	ADD BX,AX
	CMP BX,255
	JA @@Ohoh

	MOV [AfterCount],AX
	JMP @@DoCopies

@@Ohoh:
	SUB BX,255
	SUB AX,BX
	MOV [AfterCount],AX
	MOV BL,255

@@DoCopies:
	MOV [ES:DI],BL
	INC DI

	MOV CX,DX
	JCXZ @@DoIn

	SHR CX,1
	JNC @@DoWords1

	MOVSB

@@DoWords1:
	REP MOVSW

@@DoIn:
	MOV CX,[InCount]
	JCXZ @@DoAfter

	LDS SI,[SubString]
	INC SI

	SHR CX,1
	JNC @@DoWords2

	MOVSB

@@DoWords2:
	REP MOVSW

@@DoAfter:
	MOV CX,[AfterCount]
	JCXZ @@Done

	LDS SI,[Source]
	INC SI
	ADD SI,DX

	SHR CX,1
	JNC @@DoWords3

	MOVSB

@@DoWords3:
	REP MOVSW

@@Done:
	POP DS
END;

FUNCTION StringJustifyRight(Source: STRING; Width: BYTE; JustifyChar: CHAR): STRING;
ASSEMBLER;
ASM
	CLD

	MOV BX,DS

	LDS SI,[Source]
	LES DI,[@Result]

	LODSB
	XOR AH,AH

	MOV DL,AL
	MOV DH,[Width]

	CMP DH,0
	JE @@WidthTooSmall

	CMP DH,DL
	JAE @@Label1

	MOV AL,DL
	SUB AL,DH
	ADD SI,AX
	MOV DL,DH

@@Label1:
	MOV AL,DH
	STOSB

	SUB AL,DL
	MOV CL,AL
	XOR CH,CH

	MOV AL,[JustifyChar]
	MOV AH,AL

	SHR CX,1
	JNC @@DoWords1

	STOSB

@@DoWords1:
	REP STOSW

@@CopySource:
	MOV CL,DL
	SHR CL,1
	JNC @@DoWords2

	MOVSB

@@DoWords2:
	REP MOVSW
	JMP @@Done

@@WidthTooSmall:
	MOV [BYTE PTR ES:DI],0H

@@Done:
	MOV DS,BX
END;

FUNCTION StringJustifyLeft(Source: STRING; Width: BYTE; JustifyChar: CHAR): STRING;
ASSEMBLER;
ASM
	CLD

	MOV BX,DS

	LDS SI,[Source]
	LES DI,[@Result]

	LODSB
	XOR AH,AH

	MOV DL,AL
	MOV DH,[Width]

	CMP DH,0
	JE @@WidthTooSmall

	CMP DH,DL
	JAE @@Label1

	MOV DL,DH

@@Label1:
	MOV AL,DH
	STOSB

@@CopySource:
	MOV CL,DL
	XOR CH,CH

	SHR CL,1
	JNC @@DoWords1

	MOVSB

@@DoWords1:
	REP MOVSW

@@AddJustification:
	MOV AL,[JustifyChar]
	MOV AH,AL

	MOV CL,DH
	SUB CL,DL

	SHR CL,1
	JNC @@DoWords2

	STOSB

@@DoWords2:
	REP STOSW
	JMP @@Done

@@WidthTooSmall:
	MOV [BYTE PTR ES:DI],0H

@@Done:
	MOV DS,BX
END;

FUNCTION StringJustifyCenter(Source: STRING; Width: BYTE; JustifyChar: CHAR): STRING;
ASSEMBLER;
ASM
	CLD

	PUSH DS

	LDS SI,[Source]
	LES DI,[@Result]

	LODSB

	MOV DL,AL
	MOV DH,[Width]

	CMP DH,0
	JE @@WidthTooSmall

	CMP DH,DL
	JAE @@Label1

	SHR AL,1
	MOV BL,DH
	SHR BL,1
	SUB AL,BL
	ADD SI,AX
	MOV DL,DH

@@Label1:
	MOV AL,DH
	STOSB

@@AddStartSpaces:
	SUB AL,DL
	MOV CL,AL
	XOR CH,CH

	SHR CL,1
	PUSHF
	MOV BH,CL

	MOV AL,[JustifyChar]
	MOV AH,AL

	SHR CL,1
	JNC @@DoWords1

	STOSB

@@DoWords1:
	REP STOSW

@@CopySource:
	MOV CL,DL
	SHR CL,1
	JNC @@DoWords2

	MOVSB

@@DoWords2:
	REP MOVSW

@@AddEndSpaces:
	POPF
	JNC @@Label2

	STOSB

@@Label2:
	MOV CL,BH
	SHR CL,1
	JNC @@DoWords3

	STOSB

@@DoWords3:
	REP STOSW
	JMP @@Done

@@WidthTooSmall:
	XOR AL,AL
	STOSB

@@Done:
	POP DS
END;

FUNCTION StringTrimRight(Source: STRING; Garbage: STRING): STRING;
ASSEMBLER;
ASM
	CLD

	PUSH DS

	LDS SI,[Source]
	LODSB
	XOR AH,AH

	MOV DX,AX
	CMP DX,0
	JE @@EmptyResult

	LES DI,[Garbage]
	MOV BL,[ES:DI]
	XOR BH,BH
	INC DI
	CMP BX,0
	JE @@Copy

	ADD SI,DX
	DEC SI

	PUSH BP
	MOV BP,DI

@@ScanLoop:
	MOV AL,[DS:SI]
	DEC SI

	MOV DI,BP
	MOV CX,BX
	REPNE SCASB
	JNE @@DoneScan

	DEC DX
	JNZ @@ScanLoop

@@DoneScan:
	POP BP

@@Copy:
	MOV CX,DX
	MOV SI,[WORD PTR Source]
	INC SI
	LES DI,[@Result]
	MOV [ES:DI],CL
	INC DI

	SHR CX,1
	JNC @@DoWords

	MOVSB

@@DoWords:
	REP MOVSW
	JMP @@Done

@@EmptyResult:
	LES DI,[@Result]
	MOV [BYTE PTR ES:DI],0H

@@Done:
	POP DS
END;

FUNCTION StringTrimLeft(Source: STRING; Garbage: STRING): STRING;
ASSEMBLER;
ASM
	CLD

	PUSH DS

	LDS SI,[Source]
	LODSB
	XOR AH,AH

	MOV DX,AX
	CMP DX,0
	JE @@EmptyResult

	LES DI,[Garbage]
	MOV BL,[ES:DI]
	XOR BH,BH
	INC DI
	CMP BX,0
	JE @@Copy

	PUSH BP
	MOV BP,DI

@@ScanLoop:
	LODSB

	MOV DI,BP
	MOV CX,BX
	REPNE SCASB
	JNE @@DoneScan

	DEC DX
	JNZ @@ScanLoop

@@DoneScan:
	POP BP
	DEC SI

@@Copy:
	MOV CX,DX
	LES DI,[@Result]
	MOV [ES:DI],CL
	INC DI

	SHR CX,1
	JNC @@DoWords

	MOVSB

@@DoWords:
	REP MOVSW
	JMP @@Done

@@EmptyResult:
	LES DI,[@Result]
	MOV [BYTE PTR ES:DI],0H

@@Done:
	POP DS
END;

FUNCTION StringReplicate(Source: STRING; Count: BYTE): STRING;
ASSEMBLER;
ASM
	CLD

	PUSH DS
	PUSH BP

	XOR CX,CX

	LDS SI,[Source]
	LES DI,[@Result]

	LODSB
	CMP AL,0
	JE @@ZeroResult

	MOV BL,[Count]
	XOR BH,BH
	CMP BX,0
	JE @@ZeroResult

	MOV DL,AL
	XOR DH,DH

	INC DI
	MOV BP,SI

@@FillLoop:
	MOV SI,BP

	MOV CL,DL
	ADD DH,DL
	JNC @@Copy

	SUB DL,DH
	MOV CL,DL
	DEC CL
	MOV DH,0FFH
	SHR CX,1
	JNC @@DoWords1

	MOVSB

@@DoWords1:
	REP MOVSW
	JMP @@Filled

@@Copy:
	SHR CX,1
	JNC @@DoWords2

	MOVSB

@@DoWords2:
	REP MOVSW

	DEC BX
	JNZ @@FillLoop

@@Filled:
	POP BP
	PUSH BP
	MOV DI,[WORD PTR @Result]
	MOV [ES:DI],DH
	JMP @@Done

@@ZeroResult:
	MOV [BYTE PTR ES:DI],0

@@Done:
	POP BP
	POP DS
END;

FUNCTION StringTrimAll(Source: STRING; Garbage: STRING): STRING;
ASSEMBLER;
VAR
	Count: WORD;
ASM
	CLD

	PUSH DS

	LDS SI,[Source]
	LODSB
	XOR AH,AH
	MOV [Count],AX
	CMP AX,0
	JE @@EmptyResult

	LES DI,[Garbage]
	MOV AL,[ES:DI]
	INC DI
	CMP AL,0
	JE @@Copy

	MOV BX,AX
	MOV DX,DI

@@LeftTrimming:
	LODSB

	MOV CX,BX
	REPNE SCASB
	MOV DI,DX
	JNE @@DoneLeftTrimming

	DEC [Count]
	JNZ @@LeftTrimming

	JMP @@EmptyResult

@@DoneLeftTrimming:
	DEC SI
	PUSH SI
	ADD SI,[Count]
	DEC SI

@@RightTrimming:
	MOV AL,[DS:SI]
	DEC SI

	MOV CX,BX
	REPNE SCASB
	MOV DI,DX
	JNE @@DoneRightTrimming

	DEC [Count]
	JNZ @@RightTrimming

	POP SI
	JMP @@EmptyResult

@@DoneRightTrimming:
	POP SI

@@Copy:
	MOV CX,[Count]
	LES DI,[@Result]
	MOV [ES:DI],CL
	INC DI
	SHR CX,1
	JNC @@DoWords

	MOVSB

@@DoWords:
	REP MOVSW
	JMP @@Done

@@EmptyResult:
	LES DI,[@Result]
	MOV [BYTE PTR ES:DI],0H

@@Done:
	POP DS
END;

FUNCTION StringJustifyWrap(Source: STRING; Width: BYTE; WordDelimiters: STRING; JustifyChar: CHAR): STRING;
ASSEMBLER;
VAR
	SaveES1,SaveDI1: WORD;
ASM
	CLD

	PUSH DS

	XOR CX,CX

	LDS SI,[Source]
	LES DI,[@Result]

	LODSB
	MOV DL,AL
	CMP DL,0
	JE @@ZeroResult

	CMP [Width],0
	JE @@ZeroResult

	MOV CX,ES
	MOV [SaveES1],CX
	MOV [SaveDI1],DI

	XOR AH,AH
	XOR BH,BH
	XOR DH,DH

	MOV CL,DL

	PUSH SI
	LES DI,[WordDelimiters]
	PUSH DI

@@ScanLoop1:
	LODSB

	POP DI
	PUSH DI
	PUSH CX
	XOR CH,CH
	MOV CL,[ES:DI]
	INC DI
	REPNE SCASB
	POP CX
	JE @@YesIt1

	INC DH
	XOR AH,AH
	JMP @@NextChar1

@@YesIt1:
	CMP AH,0
	JNE @@NextChar1

	INC BH
	MOV AH,99

@@NextChar1:
	DEC CL
	JNZ @@ScanLoop1

	POP DI
	POP SI

	CMP BH,0
	JE @@CopySources

	XOR AH,AH
	MOV AL,[Width]
	ADD DH,BH
	CMP AL,DH
	JAE @@NoLengthAdjust

	MOV AL,DH

@@NoLengthAdjust:
	SUB DH,BH

	PUSH CX
	XCHG DI,[SaveDI1]
	MOV CX,ES
	XCHG CX,[SaveES1]
	MOV ES,CX

	STOSB

	XCHG DI,[SaveDI1]
	MOV CX,ES
	XCHG CX,[SaveES1]
	MOV ES,CX
	POP CX

	SUB AL,DH
	DIV BH

	MOV BH,AL
	XOR DH,DH
	MOV CL,DL

	PUSH DI

@@AddSpacesLoop1:
	LODSB

	POP DI
	PUSH DI
	PUSH CX
	XOR CH,CH
	MOV CL,[ES:DI]
	INC DI
	REPNE SCASB
	POP CX
	JE @@YesIt2

	PUSH CX
	XCHG DI,[SaveDI1]
	MOV CX,ES
	XCHG CX,[SaveES1]
	MOV ES,CX

	STOSB

	XCHG DI,[SaveDI1]
	MOV CX,ES
	XCHG CX,[SaveES1]
	MOV ES,CX
	POP CX

	XOR DH,DH
	JMP @@NextChar2

@@YesIt2:
	CMP DH,0
	JNE @@NextChar2

	MOV DL,CL
	MOV DH,99
	MOV AL,[JustifyChar]

	PUSH CX
	XCHG DI,[SaveDI1]
	MOV CX,ES
	XCHG CX,[SaveES1]
	MOV ES,CX

	XOR CH,CH
	MOV CL,BH
	REP STOSB

	XCHG DI,[SaveDI1]
	MOV CX,ES
	XCHG CX,[SaveES1]
	MOV ES,CX
	POP CX

	MOV CL,DL
	CMP AH,0
	JE @@NextChar2

	DEC AH

	PUSH CX
	XCHG DI,[SaveDI1]
	MOV CX,ES
	XCHG CX,[SaveES1]
	MOV ES,CX

	STOSB

	XCHG DI,[SaveDI1]
	MOV CX,ES
	XCHG CX,[SaveES1]
	MOV ES,CX
	POP CX

@@NextChar2:
	DEC CL
	JNZ @@AddSpacesLoop1

	POP DI
	JMP @@Done

@@CopySources:
	LES DI,[@Result]
	LDS SI,[Source]
	LODSB
	STOSB
	XOR CX,CX
	MOV CL,AL
	SHR CX,1
	JNC @@CopyWords

	MOVSB

@@CopyWords:
	REP MOVSW
	JMP @@Done

@@ZeroResult:
	MOV [BYTE PTR ES:DI],0

@@Done:
	POP DS
END;

FUNCTION StringWordCount(Source: STRING; WordDelimiters: STRING): BYTE;
ASSEMBLER;
VAR
	Flag: BYTE;
ASM
	CLD

	PUSH DS

	LDS SI,[Source]
	LES DI,[WordDelimiters]
	LODSB
	MOV DH,[ES:DI]

	XOR AH,AH

	CMP AL,0
	JE @@Done

	CMP DH,0
	JE @@Done

	INC DI
	MOV BX,DI

	MOV DL,AL
	MOV [Flag],-1
	XOR CH,CH
	XOR AH,AH

@@ScanLoop1:
	LODSB
	MOV CL,DH
	MOV DI,BX
	REPNE SCASB
	JE @@DoLoop1

	CMP [Flag],AH
	JE @@DoLoop2

	INC AH
	MOV [Flag],AH
	JMP @@DoLoop2

@@DoLoop1:
	MOV [Flag],-1

@@DoLoop2:
	DEC DL
	JNZ @@ScanLoop1

@@Done:
	MOV AL,AH
	POP DS
END;

FUNCTION StringWordGet(Source: STRING; WordDelimiters: STRING; Count: BYTE): STRING;
ASSEMBLER;
VAR
	Flag: BYTE;
	Var1: WORD;
ASM
	CLD

	PUSH DS

	LDS SI,[Source]
	LES DI,[WordDelimiters]
	LODSB
	XOR AH,AH
	MOV DH,[ES:DI]
	CMP DH,0
	JE @@NoFate

	INC DI
	MOV BX,DI
	MOV CX,AX
	JCXZ @@NoFate

	CMP [Count],0
	JE @@NoFate

	MOV [Flag],-1

@@ScanLoop1:
	LODSB
	MOV DL,CL
	MOV CL,DH
	MOV DI,BX
	REPNE SCASB
	JE @@DoLoop1

	CMP [Flag],AH
	JE @@DoLoop2

	INC AH
	CMP AH,[Count]
	JNE @@Label1

	MOV [Var1],SI
	DEC [Var1]

@@Label1:
	MOV [Flag],AH
	JMP @@DoLoop2

@@DoLoop1:
	MOV [Flag],-1
	CMP AH,[Count]
	JE @@DoneGet

@@DoLoop2:
	MOV CL,DL
	LOOP @@ScanLoop1

	INC SI
	CMP AH,[Count]
	JE @@DoneGet

@@NoFate:
	LES DI,[@Result]
	MOV WORD PTR [ES:DI],0
	JMP @@Done

@@DoneGet:
	MOV AX,SI
	SUB AX,[Var1]
	DEC AX
	LES DI,[@Result]
	STOSB
	MOV CX,AX
	MOV SI,[Var1]
	SHR CX,1
	JNC @@DoWords

	MOVSB

@@DoWords:
	REP MOVSW

@@Done:
	POP DS
END;

FUNCTION StringWordPos(Source: STRING; WordDelimiters: STRING; Count: BYTE): BYTE;
ASSEMBLER;
VAR
	Flag: BYTE;
	Var1: WORD;
ASM
	CLD

	PUSH DS

	LDS SI,[Source]
	LES DI,[WordDelimiters]
	LODSB
	XOR AH,AH
	MOV DH,[ES:DI]
	CMP DH,0
	JE @@NoFate

	INC DI
	MOV BX,DI
	MOV CX,AX
	JCXZ @@NoFate

	CMP [Count],0
	JE @@NoFate

	MOV [Flag],-1

@@ScanLoop1:
	LODSB
	MOV DL,CL
	MOV CL,DH
	MOV DI,BX
	REPNE SCASB
	JE @@DoLoop1

	CMP [Flag],AH
	JE @@DoLoop2

	INC AH
	CMP AH,[Count]
	JNE @@Label1

	MOV [Var1],SI
	DEC [Var1]

@@Label1:
	MOV [Flag],AH
	JMP @@DoLoop2

@@DoLoop1:
	MOV [Flag],-1
	CMP AH,[Count]
	JE @@DoneGet

@@DoLoop2:
	MOV CL,DL
	LOOP @@ScanLoop1

	INC SI
	CMP AH,[Count]
	JE @@DoneGet

@@NoFate:
	MOV AL,0
	JMP @@Done

@@DoneGet:
	MOV AX,[Var1]
	SUB AX,[WORD PTR Source]

@@Done:
	POP DS
END;

END.